//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#include <OwnMessage.h>

namespace test {

OwnMessage::OwnMessage(const char* name) : cMessage(name){
    EV << "Constructor of OwnMessage: creating new message with name '" << this->getName() << "' and id '" << this->getId() << "'\n";
}

OwnMessage::~OwnMessage() {
    EV << "Destructor of OwnMessage: deconstructing message with name '" << this->getName() << "' and id '" << this->getId() << "'\n";
}

OwnMessage::OwnMessage(const OwnMessage& toCopy) : cMessage(toCopy){
    EV << "CopyConstructor of OwnMessage: creating new message with name '" << this->getName() << "' and id '" << this->getId()
       << " as copy from message with id '"<< toCopy.getId() << "'\n";
}

} /* namespace test */
